# coding: utf-8

"""
    Model Management Service

    Model Management System (MMS) is a version control system for structured data. It exposes model information through RESTful web services that can be used for CRUD operations, branching, and tagging of the model repository.  # noqa: E501

    OpenAPI spec version: 3.3.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class Ref(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'parent_ref_id': 'str',
        'type': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'parent_ref_id': 'parentRefId',
        'type': 'type'
    }

    def __init__(self, id=None, name=None, parent_ref_id=None, type='Branch'):  # noqa: E501
        """Ref - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._name = None
        self._parent_ref_id = None
        self._type = None
        self.discriminator = None

        self.id = id
        self.name = name
        if parent_ref_id is not None:
            self.parent_ref_id = parent_ref_id
        self.type = type

    @property
    def id(self):
        """Gets the id of this Ref.  # noqa: E501


        :return: The id of this Ref.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Ref.


        :param id: The id of this Ref.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this Ref.  # noqa: E501


        :return: The name of this Ref.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Ref.


        :param name: The name of this Ref.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def parent_ref_id(self):
        """Gets the parent_ref_id of this Ref.  # noqa: E501


        :return: The parent_ref_id of this Ref.  # noqa: E501
        :rtype: str
        """
        return self._parent_ref_id

    @parent_ref_id.setter
    def parent_ref_id(self, parent_ref_id):
        """Sets the parent_ref_id of this Ref.


        :param parent_ref_id: The parent_ref_id of this Ref.  # noqa: E501
        :type: str
        """

        self._parent_ref_id = parent_ref_id

    @property
    def type(self):
        """Gets the type of this Ref.  # noqa: E501


        :return: The type of this Ref.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Ref.


        :param type: The type of this Ref.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["Branch", "Tag"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Ref):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
